//+------------------------------------------------------------------+
//|                                                      _PR_v01.mq4 |
//|                                                      by olyakish |
//|                                         for-new-email@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "by olyakish"
#property link      "for-new-email@rambler.ru"


extern int        barn=100;
extern int        Length=6;
extern string     r01="  ( 1  3)";
extern int        CountOrders=3;
extern int        MagicStart=1000;

double Start,OldStart;
double Stop,OldStop;
double Target[3];
double Ticket[3];
bool OpenTrade=true;
double lots[3]={0.3,0.2,0.1};
int time;
//*********************************************************************************************************
bool ( int type,int magic)
   {
    if (OrdersTotal()!=0) //     
      {
         for (int i=OrdersTotal()-1;i>=0;i--)
            {
               OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
               if (OrderMagicNumber()>=magic && OrderMagicNumber()<=magic+3)
                  {
                     if (OrderType()>=2){OrderDelete(OrderTicket());}   //   
                     RefreshRates();
                     if (OrderType()==OP_BUY){OrderClose(OrderTicket(),OrderLots(),Bid,5,Lime);}
                     if (OrderType()==OP_SELL){OrderClose(OrderTicket(),OrderLots(),Ask,5,Lime);}
                  }
            }
      }   
      return(0);
   }

//*********************************************************************************************************
bool (int type,double start, double stop, double target[],int magic)
   {
      int ii;
      double spread=MarketInfo(Symbol(),MODE_SPREAD)*MarketInfo(Symbol(),MODE_POINT);
      double dist=MarketInfo(Symbol(),MODE_POINT)*MarketInfo(Symbol(),MODE_STOPLEVEL);
      int cmd=-1;
         {
            RefreshRates();
            if (type==OP_BUY)
               {
                  for (ii=0;ii<CountOrders;ii++)
                     {
                        if (Ticket[ii]<=0)
                           {
                              if (Ask+1.5*dist<Start){cmd=OP_BUYSTOP;}
                              if (Ask-1.5*dist>Start){cmd=OP_BUYLIMIT;}
                              if (cmd>0){Ticket[ii]=OrderSend(Symbol(),cmd,lots[ii],start+spread,0,stop,target[ii],StringConcatenate("Buy",magic+ii),magic,0,Aqua);}
                              if (Ask==Start)   
                                 {
                                    cmd=OP_BUY;
                                    Ticket[ii]=OrderSend(Symbol(),cmd,lots[ii],NormalizeDouble(Ask,Digits),0,stop,target[ii],StringConcatenate("Buy",magic+ii),magic,0,Aqua);      
                                 }
                           }
                     }
               }
            if (type==OP_SELL)
               {
                  for (ii=0;ii<CountOrders;ii++)
                     {
                        if (Ticket[ii]<=0)
                           {
                              if (Bid+dist<Start){cmd=OP_SELLLIMIT;}
                              if (Bid-dist>Start){cmd=OP_SELLSTOP;}
                              if (cmd>0){Ticket[ii]=OrderSend(Symbol(),cmd,lots[ii],start,0,stop,target[ii],StringConcatenate("Sell",magic+ii),magic,0,Aqua);}
                              if (Bid==Start)
                                 {
                                    cmd=OP_SELL;
                                    Ticket[ii]=OrderSend(Symbol(),cmd,lots[ii],NormalizeDouble(Bid,Digits),0,stop,target[ii],StringConcatenate("Sell",magic+ii),magic,0,Aqua);      
                                 }   
                           }
                     }
               }               
         }
      for (int y=0;y<CountOrders;y++){if (Ticket[y]<=0){return(false);}}
      return(true);
   }

//*********************************************************************************************************
bool ()
   {
    if (OrdersTotal()!=0) //     
      {
         for (int i=OrdersTotal()-1;i>=0;i--)
            {
               OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
               if (OrderType()==OP_BUY)   //  
                  {
                     RefreshRates();
                     if (Bid>Target[1] && OrderStopLoss()-Target[0]<0)
                        {
                           OrderModify(OrderTicket(),OrderOpenPrice(),Target[0],OrderTakeProfit(),0,Gold);
                        }
                     if (Bid>Target[0] && OrderStopLoss()-Start<Point)
                        {
                           OrderModify(OrderTicket(),OrderOpenPrice(),Start,OrderTakeProfit(),0,Gold);
                        }
                  }
               if (OrderType()==OP_SELL)   //  sell
                  {
                     RefreshRates();
                     if (Ask<Target[1] && OrderStopLoss()-Target[0]>0)
                        {
                           OrderModify(OrderTicket(),OrderOpenPrice(),Target[0],OrderTakeProfit(),0,Gold);
                        }
                     if (Ask<Target[0] && OrderStopLoss()-Start>Point)
                        {
                           //Print("Ask",DoubleToStr(Ask*100000000,8), " Target[0]",DoubleToStr(Target[0]*100000000,8)," SL=",DoubleToStr(OrderStopLoss()*100000000,8),"  Stop=",DoubleToStr(Start*100000000,8), " OrdersTotal=",OrdersTotal());
                           OrderModify(OrderTicket(),OrderOpenPrice(),Start,OrderTakeProfit(),0,Gold);
                        }
                  }                  
            }
      }      
      return(true);
   }

//*********************************************************************************************************
int start()
  {
      int shift,Swing,Swing_n,uzl,i,zu,zd,mv;
      double PointA,PointB,PointC,Fantnsy,CrazyDream;
      double LL,HH,BH,BL,NH,NL; 
      double Uzel[10000][3]; 
      string text;
      // loop from first bar to current bar (with shift=0) 
      Swing_n=0;Swing=0;uzl=0; 
      BH =High[barn];BL=Low[barn];zu=barn;zd=barn; 

      for(shift=barn;shift>=0;shift--) 
         { 
            LL=10000000;
            HH=-100000000; 
            for(i=shift+Length;i>=shift+1;i--) 
               { 
                  if(Low[i]< LL) LL=Low[i]; 
                  if(High[i]>HH) HH=High[i]; 
               } 
            if(Low[shift]<LL && High[shift]>HH)
               { 
                  Swing=2; 
                  if(Swing_n==1) zu=shift+1; 
                  if(Swing_n==-1) zd=shift+1; 
               } 
            else 
               { 
                  if(Low[shift]<LL) Swing=-1; 
                  if(High[shift]>HH) Swing=1; 
               } 
            if(Swing!=Swing_n && Swing_n!=0) 
               { 
                  if(Swing==2) 
                     {
                        Swing=-Swing_n;
                        BH = High[shift];
                        BL = Low[shift]; 
                     } 
                  uzl=uzl+1; 
                  if(Swing==1) 
                     {
                        Uzel[uzl][1]=zd;
                        Uzel[uzl][2]=BL;
                     } 
                  if(Swing==-1) 
                     {
                        Uzel[uzl][1]=zu;
                        Uzel[uzl][2]=BH; 
                     } 
                  BH=High[shift];
                  BL=Low[shift]; 
               } 
            if(Swing==1) 
               { 
                  if(High[shift]>=BH) 
                     {
                        BH=High[shift];
                        zu=shift;
                     }
               } 
            if(Swing==-1) 
               {
                  if(Low[shift]<=BL) 
                     {
                        BL=Low[shift]; 
                        zd=shift;
                     }
               } 
            Swing_n=Swing; 
         } 
      ///--------------------------------
      PointA = Uzel[uzl-2][2];
      PointB = Uzel[uzl-1][2];
      PointC = Uzel[uzl][2];

      Target[0]=NormalizeDouble((PointB-PointA)*0.618+PointC,4);
      Target[1]=PointB-PointA+PointC;
      Target[2]=NormalizeDouble((PointB-PointA)*1.618+PointC,4);
      Fantnsy=NormalizeDouble((PointB-PointA)*2.618+PointC,4);
      CrazyDream=NormalizeDouble((PointB-PointA)*4.618+PointC,4);
      if (PointB<PointC)
         {
            Start=NormalizeDouble((PointB-PointA)*0.318+PointC,4)-(Ask-Bid);
            Stop=PointC+2*(Ask-Bid);
         }
      if (PointB>PointC)
         {
            Start=NormalizeDouble((PointB-PointA)*0.318+PointC,4)+(Ask-Bid);
            Stop=PointC-2*(Ask-Bid);
         }
      
      /////////////// trade
      
      if (!OpenTrade && ((OldStart>OldStop && Start<Stop) || (OldStart<OldStop && Start>Stop))){OpenTrade=true;time=Time[1];}
      if (!OpenTrade){();}  
      if (OpenTrade==true)
         {
            if (Start>Stop && time!=Time[1]) //     
               {
                  (OP_SELL,MagicStart);
                  if ((OP_BUY,Start,Stop,Target,MagicStart))
                     {                        
                        OpenTrade=false;
                        OldStart=Start;                        
                        OldStop=Stop;
                        ArrayInitialize(Ticket,0);
                     }
               }  
            if (Start<Stop && time!=Time[1]) //     
               {
                  (OP_BUY,MagicStart);
                  if((OP_SELL,Start,Stop,Target,MagicStart))
                     {                       
                        OpenTrade=false;                        
                        OldStart=Start;
                        OldStop=Stop;
                        ArrayInitialize(Ticket,0);
                     }
               }
         }
   
   return(0);
  }
//+------------------------------------------------------------------+

